// Persistence of Vision Ray Tracer Scene Description File
// File: iso_csg_test06.pov
// Vers: 3.5
// Desc: demo for IC_Merge_Array() and
//       IC_Displace() from the IsoCSG include file
// Date: Apr. 2002
// Auth: Christoph Hormann
//
       
#version 3.5;

global_settings {
  assumed_gamma 1.0 
}   

background { color <0.750,0.500,0.300> } 
    
camera {
  location <0.2,0.2,-1>  
  look_at  <0,0,0>
  right (4/3)*x 
  angle 40               
} 

light_source {     
  <1000, 2500, -5000> 
  color rgb 1.2
}      

#include "iso_csg.inc" 
               
#declare IC_Arr=array[12]   
                      
#declare IC_Arr[0]=IC_Merge2(IC_Cone(0, 0, x+y, 0.3), IC_Cone(x+y, 0.3, (x+y)*2, 1.6) )                     
#declare IC_Arr[1]=IC_Rotate(IC_Arr[0], 30*z)                   
#declare IC_Arr[2]=IC_Rotate(IC_Arr[0], 60*z)
#declare IC_Arr[3]=IC_Rotate(IC_Arr[0], 90*z)
#declare IC_Arr[4]=IC_Rotate(IC_Arr[0], 120*z)
#declare IC_Arr[5]=IC_Rotate(IC_Arr[0], 150*z)     
#declare IC_Arr[6]=IC_Rotate(IC_Arr[0], 180*z)
#declare IC_Arr[7]=IC_Rotate(IC_Arr[0], 210*z)
#declare IC_Arr[8]=IC_Rotate(IC_Arr[0], 240*z)      
#declare IC_Arr[9]=IC_Rotate(IC_Arr[0], 270*z)    
#declare IC_Arr[10]=IC_Rotate(IC_Arr[0], 300*z)      
#declare IC_Arr[11]=IC_Rotate(IC_Arr[0], 330*z)   
   
#declare fn_Disp= 
function { pattern { onion sine_wave scale 0.6 } }

#declare fn_XX= IC_Merge_Array(IC_Arr)

 
            
isosurface {
                                                                                                                       
  IC_Displace(
    fn_XX,           
    function(x, y, z) { fn_Disp(x, y, z)*0.03 } 
  ) 
    
  max_gradient 2.4 
  contained_by { box { -3, 3 } }
  pigment { rgb <0, 0.2, 1.1> } 
  finish { specular 0.3 } 
  scale 0.08
}     
      

 