// Persistence of Vision Ray Tracer Scene Description File
// File: iso_csg_test07.pov
// Vers: 3.5
// Desc: iso_chars.inc demo
// Date: Apr. 2002
// Auth: Christoph Hormann
//

#version 3.5;

global_settings {
  assumed_gamma 1.0 
}
    
camera {
  orthographic
  location <0,0,-1>  
  look_at  <0,0,0>
  right (4/3)*x       
  up 1*y                 
}     


#include "iso_csg.inc"    
#include "iso_chars.inc" 


#local f_sample=IC_Merge5(
                  IC_Text( "0123456789" , 1 , 0 ),
    IC_Translate( IC_Text( "ABCDEFGHIJ" , 1 , 0 ) , -y*7 ),
    IC_Translate( IC_Text( "KLMNOPQRST" , 1 , 0 ) , -y*14 ),
    IC_Translate( IC_Text( "UVWXYZ!@#$" , 1 , 0 ) , -y*21 ),
    IC_Translate( IC_Text( "%^&*()[]+-" , 1 , 0 ) , -y*28 )
  );      
                                                                      
#declare fn_XX=function { f_sample(x, y, z) }
 
plane {  
  -z, 0
  texture {
    pigment { 
      function {
        min(max((fn_XX(x, y, 0)+0.5)*0.5, 0), 1)
      }
      
      color_map { 
        [0.25 color rgb <0, 0, 0> ]
        [0.27 color rgb <0, 0, 0.4> ]
        [0.45 color rgb <0, 0.2, 0.5> ]
        [0.49 color rgb <0, 0.2, 0.5> ] 
        [0.49 color rgb <0, 0, 0> ]   
        [0.51 color rgb <0, 0, 0> ]
        [0.51 color rgb <1, 0.7, 0.4> ]
        [0.70 color rgb <0.3, 0.4, 0.3> ]
      } 
        
      translate <-24, 12, 0>        
      scale 0.024  
    }
    finish {
      ambient 1
      diffuse 0
    }
  }
}  
 