// Persistence of Vision Ray Tracer Scene Description File
// File: iso_csg_test09.pov
// Vers: 3.5
// Desc: iso_csg blob macros demo
// Date: May. 2002
// Auth: Christoph Hormann
//

#declare Type=1;
       
#version 3.5;

global_settings {
  assumed_gamma 1.0 
}   

background { color <0.750,0.500,0.300> } 
    
camera {
  location <0.6,1,-0.7>*1.1  
  look_at  <0,0,0>
  right (4/3)*x 
  angle 40               
} 

light_source {     
  <1000, 3500, -5000> 
  color rgb 1.2
}      

#include "iso_csg.inc"    

         
#declare RadiusVal   = 1.5; 
#declare StrengthVal = 0.8;


#local BLOBS=array[4]

#declare BLOBS[0]=IC_BlobCylinder (<1.558, 0, -1>, <1.558, 0, 1>, RadiusVal, StrengthVal) 
#declare BLOBS[1]=IC_BlobSphere (<0, -0.9, 0>, RadiusVal, StrengthVal)
#declare BLOBS[2]=IC_BlobSphere (<0,  0.9, 0>, RadiusVal, StrengthVal)

#if (Type=1) 
  #declare BLOBS[3]=IC_BlobSphere (<1.6,  1, 0>, RadiusVal, -StrengthVal)
#else 

  #declare fn_2=IC_Box(<-0.45,-0.3,-1.1>, <1.8,-0.5,1.1>)   
       
  #declare BLOBS[3]=IC_BlobShape (fn_2, RadiusVal/3, StrengthVal)      
  
#end

#declare fn_XX= IC_Blob_Array(BLOBS, 0.65515)

 
#if (Type=1)  
  blob {
    threshold 0.65515 
    sphere { <0,  0.9, 0>, RadiusVal, StrengthVal }
    sphere { <0, -0.9, 0>, RadiusVal, StrengthVal }      
    cylinder { <1.558, 0, -1>, <1.558, 0, 1>, RadiusVal, StrengthVal }   
    sphere { <1.6, 1, 0>, RadiusVal, -StrengthVal }  
    sturm
    pigment { rgb <1.1, 0.2, 0> } 
    finish { specular 0.3 } 
    scale 0.18 
    translate <-0.38, 0, -0.2> 
  }  
#end   
 
            
isosurface {
                                                                                                                       
  function{ fn_XX(x, y, z) } 
  
  #if (Type=1)  
    max_gradient 1.5
  #else
    max_gradient 2.5
  #end
    
  accuracy 0.005 
  contained_by { box { <-1, -1.5, -1.5>, <2.6, 1.5, 1.5> } }
  pigment { rgb <0, 0.2, 1.1> } 
  finish { specular 0.3 }
  
  #if (Type=1) 
    scale 0.18     
    translate <0, 0, 0.17>   
  #else
    scale 0.24
    translate <-0.2, 0, 0>    
  #end  
}          
         
 