// Persistence of Vision Ray Tracer Scene Description File
// File: iso_csg_test12.pov
// Vers: 3.5
// Desc: iso_csg heightfield macro demo
// Date: Jun. 2003
// Auth: Christoph Hormann
//

// ----------------------------------------

#version 3.5;

global_settings {
  assumed_gamma 1
}

background { color <0.750,0.500,0.300> }

camera {
  location <0.3,0.9,-1>*7
  look_at  <0,0.2,0>
  right (4/3)*x
  angle 20
}

light_source {
  <3200, 3500, -5000>
  color rgb 1.2
}

#include "iso_csg.inc"

// ----------------------------------------

#declare fn_XX1= IC_Heightfield("hf_map.png", 0.6)

#declare fn_HF2= function { 0.2 + sin(x*9)*sin(y*9)*0.2 }

#declare fn_XX2= IC_Heightfield_Function(fn_HF2)


// ----------------------------------------
    
isosurface {

  function{ fn_XX1(x, y, z) }

  max_gradient 2.4 
  accuracy 0.001
  open       
  
  contained_by { box { <0, 0, 0>, <1, 0.6, 1> } }


  texture {
    pigment { rgb <0, 0.2, 1.1> }
    finish {
      specular 0.15
    }
  }

  translate <-0.5, 0, -0.5>
  translate <0.65, 0, -0.65> 
}  
     
isosurface {

  function{ fn_XX2(x, y, z) }

  max_gradient 2.4 
  accuracy 0.001
  open       
  
  contained_by { box { <0, 0, 0>, <1, 0.5, 1> } }


  texture {
    pigment { rgb <0, 0.2, 1.1> }
    finish {
      specular 0.15
    }
  }

  translate <-0.5, 0, -0.5>
  translate <0.65, 0, 0.65> 
}  
   
height_field {
  png "hf_map.png"
  smooth
  scale <1, 0.6, 1>  
  
  texture {
    pigment { rgb <1.1, 0.2, 0> }
    finish {
      specular 0.15
    }
  }

  translate <-0.5, 0, -0.5>
  translate <-0.65, 0, -0.65>  
}      
      
height_field {
  function 512, 512 {
    fn_HF2(x, y, z)
  }
  smooth              
  
  texture {
    pigment { rgb <1.1, 0.2, 0> }
    finish {
      specular 0.15
    }
  }

  translate <-0.5, 0, -0.5>
  translate <-0.65, 0, 0.65>  
} 

